var express = require('express');
var app = express();
var http = require('http').createServer(app);
var axios = require('axios');
var io = require('socket.io')(http);

// var BaseUrl = "http://localhost/api/";
// var BaseUrl = "https://zhibo.xueyoubangedu.com/api/";
var BaseUrl = "https://live.xueyoubangedu.com/api/";


app.get('/', function(req, res){
 res.send('<h1>Hello world</h1>');
});

io.on('connection', function(socket){
    console.log("connection");
    //监听用户登录
    socket.on('login', function(obj){
      var userid = obj.userid;
      var roomid = obj.roomid;
      socket.nickname = roomid+ '***' + userid;
      console.log("login------------------"+socket.nickname);
      socket.join(roomid);    // 加入房间

      axios.post(BaseUrl + 'websocket/login', {
        roomid: roomid,
        userid: userid
      })
      .then(function (response) {
        console.log(response.data);
        var str = socket.nickname.split("***");
        var userid = str[1];
        var roomid = str[0];
        console.log(response.data.meta.code);
        io.to(roomid).emit('Login', {userid: userid, roomid: roomid, code: response.data.meta.code});
      })
      .catch(function (error) {
        console.log(error);
      });
    });
    
    //监听中断
    socket.on('disconnect', function(obj){
      console.log('user disconnected--------'+socket.nickname);
      console.log(obj);
      if (socket.nickname) {
        axios.post(BaseUrl + 'websocket/disconnect', {
          socketName: socket.nickname
        })
        .then(function (response) {
          // console.log(response.data);
          if (response.data.meta.code == 200) {
            var str = socket.nickname.split("***");
            var userid = str[1];
            var roomid = str[0];
            var user = response.data.data;
            io.to(roomid).emit('BREAKCLASS', {userid: userid, roomid: roomid, user: user});
          }
        })
        .catch(function (error) {
          console.log(error.data);
        });
      }
    });
    //下课
    socket.on('loginout', function(obj){
      console.log("loginout----"+socket.nickname);
         // 退出房间
      if (socket.nickname) {
        axios.post(BaseUrl + 'websocket/loginout', {
          socketName: socket.nickname
        })
        .then(function (response) {
          // console.log(response.data);
          var str = socket.nickname.split("***");
          var userid = str[1];
          var roomid = str[0];
          var user = response.data.data;
          io.to(roomid).emit('ENDCLASS', {userid: userid, roomid: roomid, user: user});
        })
        .catch(function (error) {
          console.log(error);
        });
      }
    });
});


http.listen(3001, function(){
  console.log('http listening on *:3001');
});